> For the complete documentation index, see [llms.txt](https://docs.warpstream.com/warpstream/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.warpstream.com/warpstream/reference/api-reference/workspaces/create.md).

# Create

By default, this API endpoint creates a workspace as well as an application key that is authorized to manage resources inside that workspace. Pass `"skip_application_key_creation": true` to avoid creating the application key. This is useful if your integration should manage the full lifecycle of all resources in your account. For example, the official WarpStream Terraform provider sets this field to `true`.

## Request

{% code overflow="wrap" %}

```bash
curl https://api.warpstream.com/api/v1/create_workspace \
-H 'warpstream-api-key: XXXXXXXXXX' \
-H 'Content-Type: application/json' \
-d '{"workspace_name": "example-workspace", "skip_application_key_creation": false}'
```

{% endcode %}

## Response

```json
{
  "workspace_id": "wi_d7591578_418f_41cb_bed9_9c4dd7c7470e",
  "application_key": {
      "id": "aki_e6153e40_9baf_4af2_b7e0_0e88d753e50b",
      "name": "akn_example_application_key",
      "key": "aks_b0ab10f0953e30cf815c6f447f7132f2fd0c39f0bd3c2ef9ad644a58z10e9436",
      "created_at": "2024-05-11T00:20:13.365372Z",
      "access_grants": [{
        "principal_kind": "application",
        "resource_kind": "*",
        "resource_id": "*"
      }]
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.warpstream.com/warpstream/reference/api-reference/workspaces/create.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
